Index: /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/dyn1d/1D_interp_cases.h
===================================================================
--- /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/dyn1d/1D_interp_cases.h	(revision 2924)
+++ /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/dyn1d/1D_interp_cases.h	(revision 2925)
@@ -37,5 +37,5 @@
 
        alpha = rd*temp(l)*(1.+(rv/rd-1.)*q(l,1))/play(l)
-       d_th_adv(l) = ht_gcssold(l)
+       d_t_adv(l) = ht_gcssold(l)
        d_q_adv(l,1) = hq_gcssold(l)
        dt_cooling(l) = 0.0
@@ -84,5 +84,5 @@
 
        alpha = rd*temp(l)*(1.+(rv/rd-1.)*q(l,1))/play(l)
-       d_th_adv(l) = alpha*omega(l)/rcpd-(ht_mod(l)+vt_mod(l))
+       d_t_adv(l) = alpha*omega(l)/rcpd-(ht_mod(l)+vt_mod(l))
        d_q_adv(l,1) = -(hq_mod(l)+vq_mod(l))
        dt_cooling(l) = 0.0
@@ -183,5 +183,5 @@
 
        alpha = rd*temp(l)*(1.+(rv/rd-1.)*q(l,1))/play(l)
-       d_th_adv(l) = alpha*omega(l)/rcpd+ht_mod(l)-d_t_dyn_z(l)
+       d_t_adv(l) = alpha*omega(l)/rcpd+ht_mod(l)-d_t_dyn_z(l)
        d_q_adv(l,1) = hq_mod(l)-d_q_dyn_z(l)
        d_u_adv(l) = hu_mod(l)-d_u_dyn_z(l)
@@ -224,5 +224,5 @@
        ug(l)= ug_mod(l)
        vg(l)= vg_mod(l)
-       d_th_adv(l)=ht_mod(l)
+       d_t_adv(l)=ht_mod(l)
        d_q_adv(l,1)=hq_mod(l)
       enddo
@@ -315,10 +315,10 @@
 !calcul de l'advection totale
         if (cptadvw) then
-        d_th_adv(l) = alpha*omega(l)/rcpd+ht_mod(l)-d_t_dyn_z(l)
+        d_t_adv(l) = alpha*omega(l)/rcpd+ht_mod(l)-d_t_dyn_z(l)
 !        print*,'temp vert adv',l,ht_mod(l),vt_mod(l),-d_t_dyn_z(l)
         d_q_adv(l,1) = hq_mod(l)-d_q_dyn_z(l)
 !        print*,'q vert adv',l,hq_mod(l),vq_mod(l),-d_q_dyn_z(l)
         else
-        d_th_adv(l) = alpha*omega(l)/rcpd+(ht_mod(l)+vt_mod(l))
+        d_t_adv(l) = alpha*omega(l)/rcpd+(ht_mod(l)+vt_mod(l))
         d_q_adv(l,1) = (hq_mod(l)+vq_mod(l))
         endif
@@ -392,9 +392,9 @@
        alpha = rd*temp(l)*(1.+(rv/rd-1.)*q(l,1))/play(l)
 !calcul de l'advection totale
-!        d_th_adv(l) = alpha*omega(l)/rcpd+ht_mod(l)-omega(l)*d_t_z(l)
+!        d_t_adv(l) = alpha*omega(l)/rcpd+ht_mod(l)-omega(l)*d_t_z(l)
 !attention: on impose dth
-        d_th_adv(l) = alpha*omega(l)/rcpd+                                  &
+        d_t_adv(l) = alpha*omega(l)/rcpd+                                  &
      &         ht_mod(l)*(play(l)/pzero)**rkappa-omega(l)*d_t_z(l)
-!        d_th_adv(l) = 0.
+!        d_t_adv(l) = 0.
 !        print*,'temp vert adv',l,ht_mod(l),vt_mod(l),-d_t_dyn_z(l)
         d_q_adv(l,1) = hq_mod(l)-omega(l)*d_q_z(l)
@@ -417,10 +417,9 @@
 !---------------------------------------------------------------------
       if (forcing_rico) then
-!       call lstendH(llm,omega,dt_dyn,dq_dyn,du_dyn, dv_dyn,
-!     :  q,temp,u,v,play)
+!      call lstendH(llm,omega,dt_dyn,dq_dyn,du_dyn, dv_dyn,q,temp,u,v,play)
        call lstendH(llm,nqtot,omega,dt_dyn,dq_dyn,q,temp,u,v,play)
 
         do l=1,llm
-       d_th_adv(l) =  (dth_rico(l) +  dt_dyn(l))
+       d_t_adv(l) =  (dth_rico(l) +  dt_dyn(l))
        d_q_adv(l,1) = (dqh_rico(l) +  dq_dyn(l,1))
        d_q_adv(l,2) = 0.
@@ -458,27 +457,27 @@
        vg(l)= v_mod(l)
        IF((phi(l)/RG).LT.1000) THEN
-         d_th_adv(l) = (adv_theta_prof + rad_theta_prof)/3600.
+         d_t_adv(l) = (adv_theta_prof + rad_theta_prof)/3600.
          d_q_adv(l,1) = adv_qt_prof/1000./3600.
          d_q_adv(l,2) = 0.0
 !        print *,'INF1000: phi dth dq1 dq2',
-!    :  phi(l)/RG,d_th_adv(l),d_q_adv(l,1),d_q_adv(l,2)
+!    :  phi(l)/RG,d_t_adv(l),d_q_adv(l,1),d_q_adv(l,2)
        ELSEIF ((phi(l)/RG).GE.1000.AND.(phi(l)/RG).lt.3000) THEN
          fact=((phi(l)/RG)-1000.)/2000.
          fact=1-fact
-         d_th_adv(l) = (adv_theta_prof + rad_theta_prof)*fact/3600.
+         d_t_adv(l) = (adv_theta_prof + rad_theta_prof)*fact/3600.
          d_q_adv(l,1) = adv_qt_prof*fact/1000./3600.
          d_q_adv(l,2) = 0.0
 !        print *,'SUP1000: phi fact dth dq1 dq2',
-!    :  phi(l)/RG,fact,d_th_adv(l),d_q_adv(l,1),d_q_adv(l,2)
+!    :  phi(l)/RG,fact,d_t_adv(l),d_q_adv(l,1),d_q_adv(l,2)
        ELSE
-         d_th_adv(l) = 0.0
+         d_t_adv(l) = 0.0
          d_q_adv(l,1) = 0.0
          d_q_adv(l,2) = 0.0
 !        print *,'SUP3000: phi dth dq1 dq2',
-!    :  phi(l)/RG,d_th_adv(l),d_q_adv(l,1),d_q_adv(l,2)
+!    :  phi(l)/RG,d_t_adv(l),d_q_adv(l,1),d_q_adv(l,2)
        ENDIF
       dt_cooling(l) = 0.0  
 !     print *,'Interp armcu: phi dth dq1 dq2',
-!    :  l,phi(l),d_th_adv(l),d_q_adv(l,1),d_q_adv(l,2)
+!    :  l,phi(l),d_t_adv(l),d_q_adv(l,1),d_q_adv(l,2)
       enddo
       endif ! forcing_armcu
@@ -554,9 +553,9 @@
        alpha = rd*temp(l)*(1.+(rv/rd-1.)*q(l,1))/play(l)
 !
-!      d_th_adv(l) = 0.0
+!      d_t_adv(l) = 0.0
 !      d_q_adv(l,1) = 0.0
 !CR:test advection=0
 !calcul de l'advection verticale
-        d_th_adv(l) = alpha*omega(l)/rcpd-d_t_dyn_z(l)
+        d_t_adv(l) = alpha*omega(l)/rcpd-d_t_dyn_z(l)
 !        print*,'temp adv',l,-d_t_dyn_z(l)
         d_q_adv(l,1) = -d_q_dyn_z(l)
@@ -637,9 +636,9 @@
        alpha = rd*temp(l)*(1.+(rv/rd-1.)*q(l,1))/play(l)
 !
-!      d_th_adv(l) = 0.0
+!      d_t_adv(l) = 0.0
 !      d_q_adv(l,1) = 0.0
 !CR:test advection=0
 !calcul de l'advection verticale
-        d_th_adv(l) = alpha*omega(l)/rcpd-d_t_dyn_z(l)
+        d_t_adv(l) = alpha*omega(l)/rcpd-d_t_dyn_z(l)
 !        print*,'temp adv',l,-d_t_dyn_z(l)
         d_q_adv(l,1) = -d_q_dyn_z(l)
@@ -715,5 +714,7 @@
 
 !Calcul de l advection verticale
+
       d_t_dyn_z(:)=w_mod_cas(:)*d_t_z(:)
+
       d_q_dyn_z(:)=w_mod_cas(:)*d_q_z(:)
       d_u_dyn_z(:)=w_mod_cas(:)*d_u_z(:)
@@ -764,5 +765,5 @@
 
       do l = 1, llm
-       omega(l) = w_mod_cas(l)
+       omega(l) = w_mod_cas(l)  ! juste car w_mod_cas en Pa/s (MPL 20170310)
        omega2(l)= omega(l)/rg*airefi ! flxmass_w calcule comme ds physiq
        alpha = rd*temp(l)*(1.+(rv/rd-1.)*q(l,1))/play(l)
@@ -782,9 +783,9 @@
 
         if ((tend_t.eq.1).and.(tend_w.eq.0)) then
-!           d_th_adv(l)=alpha*omega(l)/rcpd+dt_mod_cas(l)
-           d_th_adv(l)=alpha*omega(l)/rcpd-dt_mod_cas(l)
+!           d_t_adv(l)=alpha*omega(l)/rcpd+dt_mod_cas(l)
+           d_t_adv(l)=alpha*omega(l)/rcpd-dt_mod_cas(l)
         else if ((tend_t.eq.1).and.(tend_w.eq.1)) then
-!           d_th_adv(l)=alpha*omega(l)/rcpd+ht_mod_cas(l)-d_t_dyn_z(l)
-           d_th_adv(l)=alpha*omega(l)/rcpd-ht_mod_cas(l)-d_t_dyn_z(l)
+!           d_t_adv(l)=alpha*omega(l)/rcpd+ht_mod_cas(l)-d_t_dyn_z(l)
+           d_t_adv(l)=alpha*omega(l)/rcpd-ht_mod_cas(l)-d_t_dyn_z(l)
         endif
 
@@ -816,5 +817,4 @@
       ENDIF
       endif ! forcing_case
-
 
 !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
@@ -877,24 +877,44 @@
       d_th_z(:)=0.
       d_q_z(:)=0.
+      d_u_z(:)=0.
+      d_v_z(:)=0.
       d_t_dyn_z(:)=0.
       d_th_dyn_z(:)=0.
       d_q_dyn_z(:)=0.
+      d_u_dyn_z(:)=0.
+      d_v_dyn_z(:)=0.
       DO l=2,llm-1
        d_t_z(l)=(temp(l+1)-temp(l-1))/(play(l+1)-play(l-1))
        d_th_z(l)=(teta(l+1)-teta(l-1))/(play(l+1)-play(l-1))
        d_q_z(l)=(q(l+1,1)-q(l-1,1))/(play(l+1)-play(l-1))
+       d_u_z(l)=(u(l+1)-u(l-1))/(play(l+1)-play(l-1))
+       d_v_z(l)=(v(l+1)-v(l-1))/(play(l+1)-play(l-1))
       ENDDO
       d_t_z(1)=d_t_z(2)
       d_th_z(1)=d_th_z(2)
       d_q_z(1)=d_q_z(2)
+      d_u_z(1)=d_u_z(2)
+      d_v_z(1)=d_v_z(2)
       d_t_z(llm)=d_t_z(llm-1)
       d_th_z(llm)=d_th_z(llm-1)
       d_q_z(llm)=d_q_z(llm-1)
+      d_u_z(llm)=d_u_z(llm-1)
+      d_v_z(llm)=d_v_z(llm-1)
 
 !Calcul de l advection verticale
-      d_t_dyn_z(:)=w_mod_cas(:)*d_t_z(:)
-      d_th_dyn_z(:)=w_mod_cas(:)*d_th_z(:)
-      d_q_dyn_z(:)=w_mod_cas(:)*d_q_z(:)
-
+! Modif w_mod_cas -> omega_mod_cas (MM+MPL 20170310)
+      d_t_dyn_z(:)=omega_mod_cas(:)*d_t_z(:)
+      d_th_dyn_z(:)=omega_mod_cas(:)*d_th_z(:)
+      d_q_dyn_z(:)=omega_mod_cas(:)*d_q_z(:)
+      d_u_dyn_z(:)=omega_mod_cas(:)*d_u_z(:)
+      d_v_dyn_z(:)=omega_mod_cas(:)*d_v_z(:)
+
+!geostrophic wind 
+      if (forc_geo.eq.1) then
+        do l=1,llm
+        ug(l) = ug_mod_cas(l) 
+        vg(l) = vg_mod_cas(l) 
+        enddo
+      endif
 !wind nudging 
       if (nudging_u.gt.0.) then
@@ -902,8 +922,8 @@
            u(l)=u(l)+timestep*(u_mod_cas(l)-u(l))/(nudge_u)
         enddo
-      else
-        do l=1,llm
-        ug(l) = u_mod_cas(l) 
-        enddo
+!     else
+!       do l=1,llm
+!          u(l) = u_mod_cas(l) 
+!       enddo
       endif
 
@@ -912,8 +932,8 @@
            v(l)=v(l)+timestep*(v_mod_cas(l)-v(l))/(nudge_v)
         enddo
-      else
-        do l=1,llm
-        vg(l) = v_mod_cas(l) 
-        enddo
+!     else
+!       do l=1,llm
+!          v(l) = v_mod_cas(l) 
+!       enddo
       endif
 
@@ -922,8 +942,8 @@
            w(l)=w(l)+timestep*(w_mod_cas(l)-w(l))/(nudge_w)
         enddo
-      else
-        do l=1,llm
-        w(l) = w_mod_cas(l) 
-        enddo
+ !    else
+ !      do l=1,llm
+ !         w(l) = w_mod_cas(l) 
+ !      enddo
       endif
 
@@ -941,43 +961,46 @@
 
       do l = 1, llm
-       omega(l) = w_mod_cas(l)
+! Modif w_mod_cas -> omega_mod_cas (MM+MPL 20170309)
+       omega(l) = omega_mod_cas(l)
        omega2(l)= omega(l)/rg*airefi ! flxmass_w calcule comme ds physiq
        alpha = rd*temp(l)*(1.+(rv/rd-1.)*q(l,1))/play(l)
 
-!calcul advection
-!       if ((tend_u.eq.1).and.(tend_w.eq.0)) then
-!          d_u_adv(l)=du_mod_cas(l)
-!       else if ((tend_u.eq.1).and.(tend_w.eq.1)) then
-!          d_u_adv(l)=hu_mod_cas(l)-d_u_dyn_z(l)
+!calcul advections
+        if ((forc_u.eq.1).and.(forc_w.eq.0)) then
+           d_u_adv(l)=du_mod_cas(l)
+        else if ((forc_u.eq.1).and.(forc_w.eq.1)) then
+           d_u_adv(l)=hu_mod_cas(l)-d_u_dyn_z(l)
+        endif
+
+        if ((forc_v.eq.1).and.(forc_w.eq.0)) then
+           d_v_adv(l)=dv_mod_cas(l)
+        else if ((forc_v.eq.1).and.(forc_w.eq.1)) then
+           d_v_adv(l)=hv_mod_cas(l)-d_v_dyn_z(l)
+        endif
+
+! Puisque dth a ete converti en dt, on traite de la meme facon 
+! les flags tadv et thadv
+        if ((tadv.eq.1.or.thadv.eq.1) .and. (forc_w.eq.0)) then
+!          d_t_adv(l)=alpha*omega(l)/rcpd-dt_mod_cas(l)
+           d_t_adv(l)=alpha*omega(l)/rcpd+dt_mod_cas(l)
+        else if ((tadv.eq.1.or.thadv.eq.1) .and. (forc_w.eq.1)) then
+!          d_t_adv(l)=alpha*omega(l)/rcpd-ht_mod_cas(l)-d_t_dyn_z(l)
+           d_t_adv(l)=alpha*omega(l)/rcpd+ht_mod_cas(l)-d_t_dyn_z(l)
+        endif
+
+!       if ((thadv.eq.1) .and. (forc_w.eq.0)) then
+!          d_t_adv(l)=alpha*omega(l)/rcpd-dth_mod_cas(l)
+!          d_t_adv(l)=alpha*omega(l)/rcpd+dth_mod_cas(l)
+!       else if ((thadv.eq.1) .and. (forc_w.eq.1)) then
+!          d_t_adv(l)=alpha*omega(l)/rcpd-hth_mod_cas(l)-d_t_dyn_z(l)
+!          d_t_adv(l)=alpha*omega(l)/rcpd+hth_mod_cas(l)-d_t_dyn_z(l)
 !       endif
-!
-!       if ((tend_v.eq.1).and.(tend_w.eq.0)) then
-!          d_v_adv(l)=dv_mod_cas(l)
-!       else if ((tend_v.eq.1).and.(tend_w.eq.1)) then
-!          d_v_adv(l)=hv_mod_cas(l)-d_v_dyn_z(l)
-!       endif
-!
-!-----------------------------------------------------
-        if (tadv.eq.1 .or. tadvh.eq.1) then
-           d_t_adv(l)=alpha*omega(l)/rcpd-dt_mod_cas(l)
-        else if (tadvv.eq.1) then
-! ATTENTION d_t_dyn_z pas calcule (voir twpice)
-           d_t_adv(l)=alpha*omega(l)/rcpd-ht_mod_cas(l)-d_t_dyn_z(l)
-        endif
-        print *,'interp_case d_t_dyn_z=',d_t_dyn_z(l),d_q_dyn_z(l)
-
-! Verifier le signe !!
-        if (thadv.eq.1 .or. thadvh.eq.1) then
-           d_th_adv(l)=dth_mod_cas(l)
-           print *,'dthadv=',d_th_adv(l)*86400.
-        else if (thadvv.eq.1) then
-           d_th_adv(l)=hth_mod_cas(l)-d_th_dyn_z(l)
-        endif
- 
-! Verifier le signe !!
-        if ((qadv.eq.1).and.(forc_w.eq.0)) then
+
+        if ((qadv.eq.1) .and. (forc_w.eq.0)) then
            d_q_adv(l,1)=dq_mod_cas(l)
-        else if ((qadvh.eq.1).and.(forc_w.eq.1)) then
+!          d_q_adv(l,1)=-1*dq_mod_cas(l)
+        else if ((qadv.eq.1) .and. (forc_w.eq.1)) then
            d_q_adv(l,1)=hq_mod_cas(l)-d_q_dyn_z(l)
+!          d_q_adv(l,1)=-1*hq_mod_cas(l)-d_q_dyn_z(l)
         endif
          
Index: /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/dyn1d/1D_nudge_sandu_astex.h
===================================================================
--- /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/dyn1d/1D_nudge_sandu_astex.h	(revision 2924)
+++ /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/dyn1d/1D_nudge_sandu_astex.h	(revision 2925)
@@ -18,5 +18,5 @@
 !     print *,'l dq1 relax dqadv',l,dq(l,1),relax_q(l,1),d_q_adv(l,1)
 !     print *,'l dq2 relax dqadv',l,dq(l,2),relax_q(l,2),d_q_adv(l,2)
-!     print *,'l dt  relax dtadv',l,dt_phys(l),relax_thl(l),d_th_adv(l)
+!     print *,'l dt  relax dtadv',l,dt_phys(l),relax_thl(l),d_t_adv(l)
       enddo
         u(1:mxcalc)=u(1:mxcalc) + timestep*(                                &          
@@ -32,3 +32,4 @@
      &      dq(1:mxcalc,2) - relax_q(1:mxcalc,2)+d_q_adv(1:mxcalc,2))
         temp(1:mxcalc)=temp(1:mxcalc)+timestep*(                            &
-     &      dt_phys(1:mxcalc)-relax_thl(1:mxcalc)+d_th_adv(1:mxcalc))
+     &      dt_phys(1:mxcalc)-relax_thl(1:mxcalc)+d_t_adv(1:mxcalc))
+
Index: /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/dyn1d/1D_read_forc_cases.h
===================================================================
--- /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/dyn1d/1D_read_forc_cases.h	(revision 2924)
+++ /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/dyn1d/1D_read_forc_cases.h	(revision 2925)
@@ -76,4 +76,5 @@
         dt_cooling(l)=thlpcar(kmax)-frac*(thlpcar(kmax)-thlpcar(kmax-1))
         do k=2,kmax
+          print *,'k l height(k) height(k-1) zlay(l) frac=',k,l,height(k),height(k-1),zlay(l),frac
           frac = (height(k)-zlay(l))/(height(k)-height(k-1))
           if(l==1) print*,'k, height, tttprof',k,height(k),tttprof(k)
@@ -227,5 +228,5 @@
 !?       omega2(l)=-rho(l)*omega(l)
        alpha = rd*temp(l)*(1.+(rv/rd-1.)*q(l,1))/play(l)
-       d_th_adv(l) = alpha*omega(l)/rcpd-(ht_mod(l)+vt_mod(l))
+       d_t_adv(l) = alpha*omega(l)/rcpd-(ht_mod(l)+vt_mod(l))
        d_q_adv(l,1) = -(hq_mod(l)+vq_mod(l))
        d_q_adv(l,2) = 0.0
@@ -280,5 +281,5 @@
 !on applique le forcage total au premier pas de temps
 !attention: signe different de toga
-       d_th_adv(l) = alpha*omega(l)/rcpd+(ht_mod(l)+vt_mod(l))
+       d_t_adv(l) = alpha*omega(l)/rcpd+(ht_mod(l)+vt_mod(l))
        d_q_adv(l,1) = (hq_mod(l)+vq_mod(l))
        d_q_adv(l,2) = 0.0
@@ -341,7 +342,7 @@
 !on applique le forcage total au premier pas de temps
 !attention: signe different de toga
-       d_th_adv(l) = alpha*omega(l)/rcpd+ht_mod(l)
+       d_t_adv(l) = alpha*omega(l)/rcpd+ht_mod(l)
 !forcage en th
-!       d_th_adv(l) = ht_mod(l)
+!       d_t_adv(l) = ht_mod(l)
        d_q_adv(l,1) = hq_mod(l)
        d_q_adv(l,2) = 0.0
@@ -442,7 +443,7 @@
 !on applique le forcage total au premier pas de temps
 !attention: signe different de toga
-       d_th_adv(l) = alpha*omega(l)/rcpd+ht_mod(l)
+       d_t_adv(l) = alpha*omega(l)/rcpd+ht_mod(l)
 !forcage en th
-!       d_th_adv(l) = ht_mod(l)
+!       d_t_adv(l) = ht_mod(l)
        d_q_adv(l,1) = hq_mod(l)
        d_q_adv(l,2) = 0.0
@@ -557,7 +558,7 @@
 !on applique le forcage total au premier pas de temps
 !attention: signe different de toga
-!      d_th_adv(l) = alpha*omega(l)/rcpd+ht_mod(l)
+!      d_t_adv(l) = alpha*omega(l)/rcpd+ht_mod(l)
 !forcage en th
-       d_th_adv(l) = ht_mod(l)
+       d_t_adv(l) = ht_mod(l)
        d_q_adv(l,1) = hq_mod(l)
        d_q_adv(l,2) = 0.0
@@ -657,16 +658,16 @@
 ! Advective forcings are given in K or g/kg ... per HOUR
 !      IF(height(l).LT.1000) THEN
-!        d_th_adv(l) = (adv_theta_prof + rad_theta_prof)/3600.
+!        d_t_adv(l) = (adv_theta_prof + rad_theta_prof)/3600.
 !        d_q_adv(l,1) = adv_qt_prof/1000./3600.
 !        d_q_adv(l,2) = 0.0
 !      ELSEIF (height(l).GE.1000.AND.height(l).LT.3000) THEN
-!        d_th_adv(l) = (adv_theta_prof + rad_theta_prof)*
+!        d_t_adv(l) = (adv_theta_prof + rad_theta_prof)*
 !    :               (1-(height(l)-1000.)/2000.)
-!        d_th_adv(l) = d_th_adv(l)/3600.
+!        d_t_adv(l) = d_t_adv(l)/3600.
 !        d_q_adv(l,1) = adv_qt_prof*(1-(height(l)-1000.)/2000.)
 !        d_q_adv(l,1) = d_q_adv(l,1)/1000./3600.
 !        d_q_adv(l,2) = 0.0
 !      ELSE
-!        d_th_adv(l) = 0.0
+!        d_t_adv(l) = 0.0
 !        d_q_adv(l,1) = 0.0
 !        d_q_adv(l,2) = 0.0
@@ -751,7 +752,7 @@
 !?       omega2(l)=-rho(l)*omega(l)
        alpha = rd*temp(l)*(1.+(rv/rd-1.)*q(l,1))/play(l)
-!      d_th_adv(l) = alpha*omega(l)/rcpd+vt_mod(l)
+!      d_t_adv(l) = alpha*omega(l)/rcpd+vt_mod(l)
 !      d_q_adv(l,1) = vq_mod(l)
-       d_th_adv(l) = alpha*omega(l)/rcpd
+       d_t_adv(l) = alpha*omega(l)/rcpd
        d_q_adv(l,1) = 0.0
        d_q_adv(l,2) = 0.0
@@ -827,7 +828,7 @@
 !      omega2(l)=-rho(l)*omega(l)
        alpha = rd*temp(l)*(1.+(rv/rd-1.)*q(l,1))/play(l)
-!      d_th_adv(l) = alpha*omega(l)/rcpd+vt_mod(l)
+!      d_t_adv(l) = alpha*omega(l)/rcpd+vt_mod(l)
 !      d_q_adv(l,1) = vq_mod(l)
-       d_th_adv(l) = alpha*omega(l)/rcpd
+       d_t_adv(l) = alpha*omega(l)/rcpd
        d_q_adv(l,1) = 0.0
        d_q_adv(l,2) = 0.0
@@ -890,9 +891,10 @@
 !on applique le forcage total au premier pas de temps
 !attention: signe different de toga
-       d_th_adv(l) = alpha*omega(l)/rcpd+(ht_mod_cas(l)+vt_mod_cas(l))
+       d_t_adv(l) = alpha*omega(l)/rcpd+(ht_mod_cas(l)+vt_mod_cas(l))
        d_q_adv(l,1) = (hq_mod_cas(l)+vq_mod_cas(l))
        d_q_adv(l,2) = 0.0
        d_u_adv(l) = (hu_mod_cas(l)+vu_mod_cas(l))
-       d_u_adv(l) = (hv_mod_cas(l)+vv_mod_cas(l))
+! correction bug d_u -> d_v (MM+MPL 20170310)
+       d_v_adv(l) = (hv_mod_cas(l)+vv_mod_cas(l))
       enddo     
 
@@ -971,8 +973,9 @@
        q(l,2) = ql_mod_cas(l)
        u(l) = u_mod_cas(l)
-       ug(l)= u_mod_cas(l)
+       ug(l)= ug_mod_cas(l)
        v(l) = v_mod_cas(l)
-       vg(l)= v_mod_cas(l)
-       omega(l) = w_mod_cas(l)
+       vg(l)= vg_mod_cas(l)
+! Modif w_mod_cas -> omega_mod_cas (MM+MPL 20170309)
+       omega(l) = omega_mod_cas(l)
        omega2(l)=omega(l)/rg*airefi ! flxmass_w calcule comme ds physiq
 
@@ -980,5 +983,5 @@
 !on applique le forcage total au premier pas de temps
 !attention: signe different de toga
-       d_th_adv(l) = alpha*omega(l)/rcpd+(ht_mod_cas(l)+vt_mod_cas(l))
+       d_t_adv(l) = alpha*omega(l)/rcpd+(ht_mod_cas(l)+vt_mod_cas(l))
        d_t_adv(l) = alpha*omega(l)/rcpd+(ht_mod_cas(l)+vt_mod_cas(l))
 !      d_q_adv(l,1) = (hq_mod_cas(l)+vq_mod_cas(l))
@@ -987,6 +990,7 @@
 !      d_u_adv(l) = (hu_mod_cas(l)+vu_mod_cas(l))
        d_u_adv(l) = du_mod_cas(l)
-!      d_u_adv(l) = (hv_mod_cas(l)+vv_mod_cas(l))
-       d_u_adv(l) = dv_mod_cas(l)
+!      d_v_adv(l) = (hv_mod_cas(l)+vv_mod_cas(l))
+! correction bug d_u -> d_v (MM+MPL 20170310)
+       d_v_adv(l) = dv_mod_cas(l)
       enddo     
 
Index: /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/dyn1d/compar1d.h
===================================================================
--- /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/dyn1d/compar1d.h	(revision 2924)
+++ /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/dyn1d/compar1d.h	(revision 2925)
@@ -41,5 +41,5 @@
 
       integer :: tadv, tadvv, tadvh, qadv, qadvv, qadvh, thadv, thadvv, thadvh, trad
-      integer :: forc_omega, forc_w, forc_geo, forc_ustar
+      integer :: forc_omega, forc_u, forc_v, forc_w, forc_geo, forc_ustar
       real    :: nudging_u, nudging_v, nudging_w, nudging_t, nudging_q
       common/com_par1d/                                                 &
Index: /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/dyn1d/lmdz1d.F90
===================================================================
--- /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/dyn1d/lmdz1d.F90	(revision 2924)
+++ /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/dyn1d/lmdz1d.F90	(revision 2925)
@@ -194,5 +194,5 @@
       real :: du_phys(llm),dv_phys(llm),dt_phys(llm)
       real :: dt_dyn(llm)
-      real :: dt_cooling(llm),d_t_adv(llm),d_th_adv(llm),d_t_nudge(llm)
+      real :: dt_cooling(llm),d_t_adv(llm),d_t_nudge(llm)
       real :: d_u_nudge(llm),d_v_nudge(llm)
       real :: du_adv(llm),dv_adv(llm)
@@ -206,5 +206,5 @@
       REAL, ALLOCATABLE, DIMENSION(:,:):: d_q_adv
       REAL, ALLOCATABLE, DIMENSION(:,:):: d_q_nudge
-!      REAL, ALLOCATABLE, DIMENSION(:):: d_th_adv
+!      REAL, ALLOCATABLE, DIMENSION(:):: d_t_adv
 
 !---------------------------------------------------------------------
@@ -271,5 +271,5 @@
       dt_dyn(:)=0.
       dt_cooling(:)=0.
-      d_th_adv(:)=0.
+      d_t_adv(:)=0.
       d_t_nudge(:)=0.
       d_u_nudge(:)=0.
@@ -404,4 +404,11 @@
        heure_ini_cas=0.
        pdt_cas=1800.         ! forcing frequency
+      elseif (forcing_type .eq.105) THEN ! bomex starts 16-12-2004 0h
+       forcing_case2 = .true.
+       year_ini_cas=1969
+       mth_ini_cas=6
+       day_deb=24
+       heure_ini_cas=0.
+       pdt_cas=1800.         ! forcing frequency
       elseif (forcing_type .eq.40) THEN
        forcing_GCSSold = .true.
@@ -573,5 +580,5 @@
       allocate(d_q_adv(llm,nqtot)) 
       allocate(d_q_nudge(llm,nqtot)) 
-!      allocate(d_th_adv(llm)) 
+!      allocate(d_t_adv(llm)) 
 
       q(:,:) = 0.
@@ -1057,5 +1064,5 @@
          fcoriolis=0.0
          dt_cooling=0.0
-         d_th_adv=0.0
+         d_t_adv=0.0
          d_q_adv=0.0
        endif
@@ -1143,6 +1150,6 @@
         if (prt_level.ge.3) then
           print *,                                                          &
-     &    'physiq-> temp(1),dt_phys(1),d_th_adv(1),dt_cooling(1) ',         &
-     &              temp(1),dt_phys(1),d_th_adv(1),dt_cooling(1)
+     &    'physiq-> temp(1),dt_phys(1),d_t_adv(1),dt_cooling(1) ',         &
+     &              temp(1),dt_phys(1),d_t_adv(1),dt_cooling(1)
            print* ,'dv_phys=',dv_phys
            print* ,'dv_age=',dv_age
@@ -1155,5 +1162,5 @@
         temp(1:mxcalc)=temp(1:mxcalc)+timestep*(                            &
      &              dt_phys(1:mxcalc)                                       &
-     &             +d_th_adv(1:mxcalc)                                      &
+     &             +d_t_adv(1:mxcalc)                                      &
      &             +d_t_nudge(1:mxcalc)                                      &
      &             +dt_cooling(1:mxcalc))  ! Taux de chauffage ou refroid.
Index: /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/ener_conserv.F90
===================================================================
--- /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/ener_conserv.F90	(revision 2924)
+++ /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/ener_conserv.F90	(revision 2925)
@@ -27,4 +27,6 @@
 USE phys_state_var_mod, ONLY : du_gwd_front,du_gwd_rando
 USE phys_output_var_mod, ONLY : bils_ec,bils_ech,bils_tke,bils_kinetic,bils_enthalp,bils_latent,bils_diss
+USE add_phys_tend_mod, ONLY : fl_cor_ebil 
+
 
 IMPLICIT none
@@ -62,9 +64,13 @@
    DO k = 1, klev
    DO i = 1, klon
-      ZRCPD = RCPD*(1.0+RVTMP2*(pqn(i,k)+pqln(i,k)+pqsn(i,k)))
-      d_t_ec(i,k)=0.5/ZRCPD &
- &      *(puo(i,k)**2+pvo(i,k)**2-pun(i,k)**2-pvn(i,k)**2)
-      ENDDO
-      ENDDO
+     IF (fl_cor_ebil .GT. 0) then
+       ZRCPD = RCPD*(1.0+RVTMP2*(pqn(i,k)+pqln(i,k)+pqsn(i,k)))
+     ELSE
+       ZRCPD = RCPD*(1.0+RVTMP2*pqn(i,k))
+     ENDIF
+     d_t_ec(i,k)=0.5/ZRCPD &
+ &     *(puo(i,k)**2+pvo(i,k)**2-pun(i,k)**2-pvn(i,k)**2)
+   ENDDO
+   ENDDO
 !-jld ec_conser
 
Index: /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/fisrtilp.F90
===================================================================
--- /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/fisrtilp.F90	(revision 2924)
+++ /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/fisrtilp.F90	(revision 2925)
@@ -103,11 +103,12 @@
   ! Options du programme:
   !
-  REAL seuil_neb ! un nuage existe vraiment au-dela
-  PARAMETER (seuil_neb=0.001)
+  REAL, SAVE :: seuil_neb=0.001 ! un nuage existe vraiment au-dela
+  !$OMP THREADPRIVATE(seuil_neb)
+
 
   INTEGER ninter ! sous-intervals pour la precipitation
   PARAMETER (ninter=5)
-  LOGICAL evap_prec ! evaporation de la pluie
-  PARAMETER (evap_prec=.TRUE.)
+  INTEGER,SAVE :: iflag_evap_prec=1 ! evaporation de la pluie
+  !$OMP THREADPRIVATE(iflag_evap_prec)
   !
   LOGICAL cpartiel ! condensation partielle
@@ -124,4 +125,7 @@
   !
   INTEGER i, k, n, kk
+  INTEGER,save::itap=0
+  !$OMP THREADPRIVATE(itap)
+
   REAL qsl, qsi
   real zct      ,zcl
@@ -154,5 +158,5 @@
   REAL t_glace_min_old
   REAL zdz(klon),zrho(klon),ztot      , zrhol(klon)
-  REAL zchau      ,zfroi      ,zfice(klon),zneb(klon)
+  REAL zchau      ,zfroi      ,zfice(klon),zneb(klon),znebprecip(klon)
   REAL zmelt, zpluie, zice
   REAL dzfice(klon)
@@ -212,4 +216,8 @@
 !CR: pour iflag_ice_thermo=2, on active que la convection
 !  ice_thermo = iflag_ice_thermo .GE. 1
+
+itap=itap+1
+znebprecip(:)=0.
+
    ice_thermo = (iflag_ice_thermo .EQ. 1).OR.(iflag_ice_thermo .GE. 3)
   zdelq=0.0
@@ -218,9 +226,12 @@
   IF (appel1er) THEN
      CALL getin_p('iflag_oldbug_fisrtilp',iflag_oldbug_fisrtilp)
+     CALL getin_p('iflag_evap_prec',iflag_evap_prec)
+     CALL getin_p('seuil_neb',seuil_neb)
      write(lunout,*)' iflag_oldbug_fisrtilp =',iflag_oldbug_fisrtilp 
      !
      WRITE(lunout,*) 'fisrtilp, ninter:', ninter
-     WRITE(lunout,*) 'fisrtilp, evap_prec:', evap_prec
+     WRITE(lunout,*) 'fisrtilp, iflag_evap_prec:', iflag_evap_prec
      WRITE(lunout,*) 'fisrtilp, cpartiel:', cpartiel
+     
      IF (ABS(dtime/REAL(ninter)-360.0).GT.0.001) THEN
         WRITE(lunout,*) 'fisrtilp: Ce n est pas prevu, voir Z.X.Li', dtime
@@ -387,5 +398,5 @@
      !   - zmqc: masse de precip qui doit etre thermalisee
      !
-     IF (evap_prec) THEN
+     IF (iflag_evap_prec>=1) THEN
         DO i = 1, klon
 !          S'il y a des precipitations
@@ -480,7 +491,13 @@
 !        S'il y a des precipitations
          IF (zrfl(i)+zifl(i).GT.0.) THEN
+
+         IF (iflag_evap_prec==1) THEN
+            znebprecip(i)=zneb(i)
+         ELSE
+            znebprecip(i)=MAX(zneb(i),znebprecip(i))
+         ENDIF
      
         ! Evap max pour ne pas saturer la fraction sous le nuage
-         zqev0 = MAX (0.0, (zqs(i)-zq(i))*zneb(i) )
+         zqev0 = MAX (0.0, (zqs(i)-zq(i))*znebprecip(i) )
 
          !JAM
@@ -567,4 +584,5 @@
          zrfl(i) = zrfln(i)
          zifl(i) = zifln(i)
+!        print*,'REEVAP ',itap,k,znebprecip(1),zqev0,zqev,zqevi,zrfl(1)
 
 !CR ATTENTION: deplacement de la fonte de la glace
@@ -595,4 +613,8 @@
            end if
 
+           ELSE
+              ! Si on n'a plus de pluies, on reinitialise a 0 la farcion
+              ! sous nuageuse utilisee pour la pluie.
+              znebprecip(i)=0.
            ENDIF ! (zrfl(i)+zifl(i).GT.0.)
         ENDDO
@@ -603,5 +625,5 @@
      ! Fin evaporation de la precipitation
      ! ----------------------------------------------------------------
-     ENDIF ! (evap_prec)
+     ENDIF ! (iflag_evap_prec>=1)
      !
      ! Calculer Qs et L/Cp*dQs/dT:
@@ -702,5 +724,5 @@
                    qcloud,ctot,zpspsk,paprs,ztla,zthl, &
                    ratqs,zqs,t)
-              elseif (iflag_cloudth_vert==3) then
+              elseif (iflag_cloudth_vert>=3) then
                call cloudth_v3(klon,klev,k,ztv, &
                    zq,zqta,fraca, &
Index: /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/oasis.F90
===================================================================
--- /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/oasis.F90	(revision 2924)
+++ /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/oasis.F90	(revision 2925)
@@ -80,5 +80,7 @@
 
   TYPE(FLD_CPL), DIMENSION(maxsend), SAVE, PUBLIC :: infosend   ! Information for sending coupling fields
+!$OMP THREADPRIVATE(infosend)
   TYPE(FLD_CPL), DIMENSION(maxrecv), SAVE, PUBLIC :: inforecv   ! Information for receiving coupling fields
+!$OMP THREADPRIVATE(inforecv)
   
   LOGICAL,SAVE :: cpl_current
Index: /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/physiq_mod.F90
===================================================================
--- /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/physiq_mod.F90	(revision 2924)
+++ /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/physiq_mod.F90	(revision 2925)
@@ -245,5 +245,5 @@
 
     USE cmp_seri_mod
-    USE add_phys_tend_mod, only : add_pbl_tend, add_phys_tend, prt_enerbil, &
+    USE add_phys_tend_mod, only : add_pbl_tend, add_phys_tend, diag_phys_tend, prt_enerbil, &
   &      fl_ebil, fl_cor_ebil
 
@@ -1682,4 +1682,5 @@
                pdtphys, &
                annee_ref, &
+               year_cur, &
                day_ref,  &
                day_ini, &
Index: /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/sisvat/sisvat.F
===================================================================
--- /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/sisvat/sisvat.F	(revision 2924)
+++ /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/sisvat/sisvat.F	(revision 2925)
@@ -7070,5 +7070,5 @@
 
       DO ig = 1,knonv
-        ztherm_i(ig)   = inertie_ice
+        ztherm_i(ig)   = inertie_lic
         IF (isnoSV(ig) > 0) ztherm_i(ig)   = inertie_sno
       ENDDO
Index: /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/soil.F90
===================================================================
--- /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/soil.F90	(revision 2924)
+++ /LMDZ5/branches/LMDZ_tree_FC/libf/phylmd/soil.F90	(revision 2925)
@@ -152,19 +152,33 @@
 !-----------------------------------------------------------------------
 !   Calcul de l'inertie thermique a partir de la variable rnat.
-!   on initialise a inertie_ice meme au-dessus d'un point de mer au cas 
+!   on initialise a inertie_sic meme au-dessus d'un point de mer au cas 
 !   ou le point de mer devienne point de glace au pas suivant
 !   on corrige si on a un point de terre avec ou sans glace
 !
-!-----------------------------------------------------------------------
+!   iophys can be used to write the ztherm_i variable in a phys.nc file
+!   and check the results; to do so, add "CALL iophys_ini" in physiq_mod
+!   and add knindex to the list of inputs in all the calls to soil.F90
+!   (and to soil.F90 itself !)
+!-----------------------------------------------------------------------
+
   IF (indice == is_sic) THEN
      DO ig = 1, knon
-        ztherm_i(ig)   = inertie_ice
+        ztherm_i(ig)   = inertie_sic
+     ENDDO
+     IF (iflag_sic == 0) THEN
+       DO ig = 1, knon
+         IF (snow(ig) > 0.0) ztherm_i(ig)   = inertie_sno
+       ENDDO
+!      Otherwise sea-ice keeps the same inertia, even when covered by snow
+     ENDIF
+!    CALL iophys_ecrit_index('ztherm_sic', 1, 'ztherm_sic', 'USI', &
+!      knon, knindex, ztherm_i)
+  ELSE IF (indice == is_lic) THEN
+     DO ig = 1, knon
+        ztherm_i(ig)   = inertie_lic
         IF (snow(ig) > 0.0) ztherm_i(ig)   = inertie_sno
      ENDDO
-  ELSE IF (indice == is_lic) THEN
-     DO ig = 1, knon
-        ztherm_i(ig)   = inertie_ice
-        IF (snow(ig) > 0.0) ztherm_i(ig)   = inertie_sno
-     ENDDO
+!    CALL iophys_ecrit_index('ztherm_lic', 1, 'ztherm_lic', 'USI', &
+!      knon, knindex, ztherm_i)
   ELSE IF (indice == is_ter) THEN
      DO ig = 1, knon
@@ -172,8 +186,13 @@
         IF (snow(ig) > 0.0) ztherm_i(ig)   = inertie_sno
      ENDDO
+!    CALL iophys_ecrit_index('ztherm_ter', 1, 'ztherm_ter', 'USI', &
+!      knon, knindex, ztherm_i)
   ELSE IF (indice == is_oce) THEN
      DO ig = 1, knon
-        ztherm_i(ig)   = inertie_ice
-     ENDDO
+!       This is just in case, but SST should be used by the model anyway
+        ztherm_i(ig)   = inertie_sic
+     ENDDO
+!    CALL iophys_ecrit_index('ztherm_oce', 1, 'ztherm_oce', 'USI', &
+!      knon, knindex, ztherm_i)
   ELSE
      WRITE(lunout,*) "valeur d indice non prevue", indice
